import java.lang.Math;

public class ControlDeCompuertas {
  private int basketsNum;
  private float minTime2Ripe;
  private float maxTime2Ripe;
  private float errorTolerance=0.08f;
  private float absoluteError, average;

  public ControlDeCompuertas(int basketsNum, float minTime2Ripe,
                             float maxTime2Ripe){
    this.basketsNum=basketsNum;
    this.minTime2Ripe=minTime2Ripe;
    this.maxTime2Ripe=maxTime2Ripe;
  }
  
  public void setMeasurements (float m1, float m2) {
    absoluteError=m1-m2;
    average = (m1+m2)/2;
  }
  public void setErrorTolerance(float tol) {
    errorTolerance=tol;
  }
  public boolean withinTolerance(){
    float relativeError=absoluteError/average;
    return Math.abs(relativeError) < errorTolerance;
  }
  public int getBasketIndex(){
    float timeRange = maxTime2Ripe-minTime2Ripe;
    float basketDispersion = timeRange/basketsNum;
	int index =(int)Math.floor((average-minTime2Ripe)/basketDispersion);
	if (index >=basketsNum)  // caso que por impresicion da average > maxTime2Ripe
		return basketsNum-1;
	if (index <0 )    // caso que por impresicion da average < minTime2Ripe
	    return 0; 
	return index;
  }
  public float getAverage(){
    return average;
  }
  public float getMinLimit(int i){
    float timeRange = maxTime2Ripe-minTime2Ripe;
    float basketDispersion = timeRange/basketsNum;
    return (minTime2Ripe+i*basketDispersion);
  }
}
